// Copyright 2013 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_BLINK_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_BLINK_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "base/callback.h"
#include "base/macros.h"
#include "base/optional.h"

#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#if BUILDFLAG(MOJO_TRACE_ENABLED)
#include "base/trace_event/trace_event.h"
#endif
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"
#include "services/device/public/mojom/bluetooth_system.mojom-shared.h"

#include "mojo/public/cpp/bindings/lib/wtf_clone_equals_util.h"
#include "mojo/public/cpp/bindings/lib/wtf_hash_util.h"
#include "third_party/blink/renderer/platform/mojo/revocable_interface_ptr.h"
#include "third_party/blink/renderer/platform/wtf/hash_functions.h"
#include "third_party/blink/renderer/platform/wtf/text/wtf_string.h"

#include "mojo/public/cpp/bindings/associated_interface_ptr.h"
#include "mojo/public/cpp/bindings/associated_interface_ptr_info.h"
#include "mojo/public/cpp/bindings/associated_interface_request.h"
#include "mojo/public/cpp/bindings/interface_ptr.h"
#include "mojo/public/cpp/bindings/interface_request.h"
#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"
#include "mojo/public/cpp/bindings/thread_safe_interface_ptr.h"
#include "third_party/blink/renderer/platform/mojo/revocable_interface_ptr.h"


#include "mojo/public/cpp/bindings/lib/native_enum_serialization.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"
#include "third_party/blink/public/platform/web_common.h"


namespace WTF {
struct device_mojom_internal_BluetoothSystem_State_DataHashFn {
  static unsigned GetHash(const ::device::mojom::BluetoothSystem_State& value) {
    using utype = std::underlying_type<::device::mojom::BluetoothSystem_State>::type;
    return DefaultHash<utype>::Hash().GetHash(static_cast<utype>(value));
  }
  static bool Equal(const ::device::mojom::BluetoothSystem_State& left, const ::device::mojom::BluetoothSystem_State& right) {
    return left == right;
  }
  static const bool safe_to_compare_to_empty_or_deleted = true;
};

template <>
struct DefaultHash<::device::mojom::BluetoothSystem_State> {
  using Hash = device_mojom_internal_BluetoothSystem_State_DataHashFn;
};

template <>
struct HashTraits<::device::mojom::BluetoothSystem_State>
    : public GenericHashTraits<::device::mojom::BluetoothSystem_State> {
  static_assert(true,
                "-1000000 is a reserved enum value");
  static_assert(true,
                "-1000001 is a reserved enum value");
  static const bool hasIsEmptyValueFunction = true;
  static bool IsEmptyValue(const ::device::mojom::BluetoothSystem_State& value) {
    return value == static_cast<::device::mojom::BluetoothSystem_State>(-1000000);
  }
  static void ConstructDeletedValue(::device::mojom::BluetoothSystem_State& slot, bool) {
    slot = static_cast<::device::mojom::BluetoothSystem_State>(-1000001);
  }
  static bool IsDeletedValue(const ::device::mojom::BluetoothSystem_State& value) {
    return value == static_cast<::device::mojom::BluetoothSystem_State>(-1000001);
  }
};
}  // namespace WTF


namespace device {
namespace mojom {
namespace blink {
class BluetoothSystemFactory;
using BluetoothSystemFactoryPtr = mojo::InterfacePtr<BluetoothSystemFactory>;
using RevocableBluetoothSystemFactoryPtr = ::blink::RevocableInterfacePtr<BluetoothSystemFactory>;
using BluetoothSystemFactoryPtrInfo = mojo::InterfacePtrInfo<BluetoothSystemFactory>;
using ThreadSafeBluetoothSystemFactoryPtr =
    mojo::ThreadSafeInterfacePtr<BluetoothSystemFactory>;
using BluetoothSystemFactoryRequest = mojo::InterfaceRequest<BluetoothSystemFactory>;
using BluetoothSystemFactoryAssociatedPtr =
    mojo::AssociatedInterfacePtr<BluetoothSystemFactory>;
using ThreadSafeBluetoothSystemFactoryAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<BluetoothSystemFactory>;
using BluetoothSystemFactoryAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<BluetoothSystemFactory>;
using BluetoothSystemFactoryAssociatedRequest =
    mojo::AssociatedInterfaceRequest<BluetoothSystemFactory>;

class BluetoothSystem;
using BluetoothSystemPtr = mojo::InterfacePtr<BluetoothSystem>;
using RevocableBluetoothSystemPtr = ::blink::RevocableInterfacePtr<BluetoothSystem>;
using BluetoothSystemPtrInfo = mojo::InterfacePtrInfo<BluetoothSystem>;
using ThreadSafeBluetoothSystemPtr =
    mojo::ThreadSafeInterfacePtr<BluetoothSystem>;
using BluetoothSystemRequest = mojo::InterfaceRequest<BluetoothSystem>;
using BluetoothSystemAssociatedPtr =
    mojo::AssociatedInterfacePtr<BluetoothSystem>;
using ThreadSafeBluetoothSystemAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<BluetoothSystem>;
using BluetoothSystemAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<BluetoothSystem>;
using BluetoothSystemAssociatedRequest =
    mojo::AssociatedInterfaceRequest<BluetoothSystem>;

class BluetoothSystemClient;
using BluetoothSystemClientPtr = mojo::InterfacePtr<BluetoothSystemClient>;
using RevocableBluetoothSystemClientPtr = ::blink::RevocableInterfacePtr<BluetoothSystemClient>;
using BluetoothSystemClientPtrInfo = mojo::InterfacePtrInfo<BluetoothSystemClient>;
using ThreadSafeBluetoothSystemClientPtr =
    mojo::ThreadSafeInterfacePtr<BluetoothSystemClient>;
using BluetoothSystemClientRequest = mojo::InterfaceRequest<BluetoothSystemClient>;
using BluetoothSystemClientAssociatedPtr =
    mojo::AssociatedInterfacePtr<BluetoothSystemClient>;
using ThreadSafeBluetoothSystemClientAssociatedPtr =
    mojo::ThreadSafeAssociatedInterfacePtr<BluetoothSystemClient>;
using BluetoothSystemClientAssociatedPtrInfo =
    mojo::AssociatedInterfacePtrInfo<BluetoothSystemClient>;
using BluetoothSystemClientAssociatedRequest =
    mojo::AssociatedInterfaceRequest<BluetoothSystemClient>;


class BluetoothSystemFactoryProxy;

template <typename ImplRefTraits>
class BluetoothSystemFactoryStub;

class BluetoothSystemFactoryRequestValidator;

class BLINK_PLATFORM_EXPORT BluetoothSystemFactory
    : public BluetoothSystemFactoryInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = BluetoothSystemFactoryProxy;

  template <typename ImplRefTraits>
  using Stub_ = BluetoothSystemFactoryStub<ImplRefTraits>;

  using RequestValidator_ = BluetoothSystemFactoryRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kCreateMinVersion = 0,
  };
  virtual ~BluetoothSystemFactory() {}

  virtual void Create(BluetoothSystemRequest system, BluetoothSystemClientPtr system_client) = 0;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemFactoryInterceptorForTesting : public BluetoothSystemFactory {
  virtual BluetoothSystemFactory* GetForwardingInterface() = 0;
  void Create(BluetoothSystemRequest system, BluetoothSystemClientPtr system_client) override;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemFactoryAsyncWaiter {
 public:
  explicit BluetoothSystemFactoryAsyncWaiter(BluetoothSystemFactory* proxy);
  ~BluetoothSystemFactoryAsyncWaiter();

 private:
  BluetoothSystemFactory* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(BluetoothSystemFactoryAsyncWaiter);
};

class BluetoothSystemProxy;

template <typename ImplRefTraits>
class BluetoothSystemStub;

class BluetoothSystemRequestValidator;
class BluetoothSystemResponseValidator;

class BLINK_PLATFORM_EXPORT BluetoothSystem
    : public BluetoothSystemInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = BluetoothSystemProxy;

  template <typename ImplRefTraits>
  using Stub_ = BluetoothSystemStub<ImplRefTraits>;

  using RequestValidator_ = BluetoothSystemRequestValidator;
  using ResponseValidator_ = BluetoothSystemResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetStateMinVersion = 0,
  };
  using State = BluetoothSystem_State;
  virtual ~BluetoothSystem() {}


  using GetStateCallback = base::OnceCallback<void(BluetoothSystem::State)>;
  virtual void GetState(GetStateCallback callback) = 0;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemInterceptorForTesting : public BluetoothSystem {
  virtual BluetoothSystem* GetForwardingInterface() = 0;
  void GetState(GetStateCallback callback) override;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemAsyncWaiter {
 public:
  explicit BluetoothSystemAsyncWaiter(BluetoothSystem* proxy);
  ~BluetoothSystemAsyncWaiter();
  void GetState(
      BluetoothSystem::State* out_state);

 private:
  BluetoothSystem* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(BluetoothSystemAsyncWaiter);
};

class BluetoothSystemClientProxy;

template <typename ImplRefTraits>
class BluetoothSystemClientStub;

class BluetoothSystemClientRequestValidator;

class BLINK_PLATFORM_EXPORT BluetoothSystemClient
    : public BluetoothSystemClientInterfaceBase {
 public:
  static const char Name_[];
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasSyncMethods_ = false;

  using Proxy_ = BluetoothSystemClientProxy;

  template <typename ImplRefTraits>
  using Stub_ = BluetoothSystemClientStub<ImplRefTraits>;

  using RequestValidator_ = BluetoothSystemClientRequestValidator;
  using ResponseValidator_ = mojo::PassThroughFilter;
  enum MethodMinVersions : uint32_t {
    kOnStateChangedMinVersion = 0,
  };
  virtual ~BluetoothSystemClient() {}

  virtual void OnStateChanged(BluetoothSystem::State new_state) = 0;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemClientInterceptorForTesting : public BluetoothSystemClient {
  virtual BluetoothSystemClient* GetForwardingInterface() = 0;
  void OnStateChanged(BluetoothSystem::State new_state) override;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemClientAsyncWaiter {
 public:
  explicit BluetoothSystemClientAsyncWaiter(BluetoothSystemClient* proxy);
  ~BluetoothSystemClientAsyncWaiter();

 private:
  BluetoothSystemClient* const proxy_;

  DISALLOW_COPY_AND_ASSIGN(BluetoothSystemClientAsyncWaiter);
};

class BLINK_PLATFORM_EXPORT BluetoothSystemFactoryProxy
    : public BluetoothSystemFactory {
 public:
  explicit BluetoothSystemFactoryProxy(mojo::MessageReceiverWithResponder* receiver);
  void Create(BluetoothSystemRequest system, BluetoothSystemClientPtr system_client) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class BLINK_PLATFORM_EXPORT BluetoothSystemProxy
    : public BluetoothSystem {
 public:
  explicit BluetoothSystemProxy(mojo::MessageReceiverWithResponder* receiver);
  void GetState(GetStateCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};

class BLINK_PLATFORM_EXPORT BluetoothSystemClientProxy
    : public BluetoothSystemClient {
 public:
  explicit BluetoothSystemClientProxy(mojo::MessageReceiverWithResponder* receiver);
  void OnStateChanged(BluetoothSystem::State new_state) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemFactoryStubDispatch {
 public:
  static bool Accept(BluetoothSystemFactory* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BluetoothSystemFactory* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BluetoothSystemFactory>>
class BluetoothSystemFactoryStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BluetoothSystemFactoryStub() {}
  ~BluetoothSystemFactoryStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemFactoryStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemFactoryStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemStubDispatch {
 public:
  static bool Accept(BluetoothSystem* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BluetoothSystem* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BluetoothSystem>>
class BluetoothSystemStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BluetoothSystemStub() {}
  ~BluetoothSystemStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemClientStubDispatch {
 public:
  static bool Accept(BluetoothSystemClient* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      BluetoothSystemClient* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<BluetoothSystemClient>>
class BluetoothSystemClientStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  BluetoothSystemClientStub() {}
  ~BluetoothSystemClientStub() override {}

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemClientStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return BluetoothSystemClientStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemFactoryRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemClientRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_PLATFORM_EXPORT BluetoothSystemResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // namespace blink
}  // namespace mojom
}  // namespace device

namespace mojo {

}  // namespace mojo

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_BLINK_H_