// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_INTERNAL_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_INTERNAL_H_

#include "mojo/public/cpp/bindings/lib/array_internal.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/map_data_internal.h"
#include "mojo/public/cpp/bindings/lib/buffer.h"
#include "mojo/public/cpp/bindings/lib/native_enum_data.h"
#include "mojo/public/interfaces/bindings/native_struct.mojom-shared-internal.h"

namespace mojo {
namespace internal {
class ValidationContext;
}
}
namespace device {
namespace mojom {
namespace internal {

struct BluetoothSystem_State_Data {
 public:
  static bool constexpr kIsExtensible = false;

  static bool IsKnownValue(int32_t value) {
    switch (value) {
      case 0:
      case 1:
      case 2:
      case 3:
      case 4:
        return true;
    }
    return false;
  }

  static bool Validate(int32_t value,
                       mojo::internal::ValidationContext* validation_context) {
    if (kIsExtensible || IsKnownValue(value))
      return true;

    ReportValidationError(validation_context,
                          mojo::internal::VALIDATION_ERROR_UNKNOWN_ENUM_VALUE);
    return false;
  }
};

#pragma pack(push, 1)
class  BluetoothSystemFactory_Create_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystemFactory_Create_Params_Data));
      new (data()) BluetoothSystemFactory_Create_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystemFactory_Create_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystemFactory_Create_Params_Data>(index_);
    }
    BluetoothSystemFactory_Create_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  mojo::internal::Handle_Data system;
  mojo::internal::Interface_Data system_client;
  uint8_t padfinal_[4];

 private:
  BluetoothSystemFactory_Create_Params_Data();
  ~BluetoothSystemFactory_Create_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystemFactory_Create_Params_Data) == 24,
              "Bad sizeof(BluetoothSystemFactory_Create_Params_Data)");
class  BluetoothSystem_GetState_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_GetState_Params_Data));
      new (data()) BluetoothSystem_GetState_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_GetState_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_GetState_Params_Data>(index_);
    }
    BluetoothSystem_GetState_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;

 private:
  BluetoothSystem_GetState_Params_Data();
  ~BluetoothSystem_GetState_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_GetState_Params_Data) == 8,
              "Bad sizeof(BluetoothSystem_GetState_Params_Data)");
class  BluetoothSystem_GetState_ResponseParams_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystem_GetState_ResponseParams_Data));
      new (data()) BluetoothSystem_GetState_ResponseParams_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystem_GetState_ResponseParams_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystem_GetState_ResponseParams_Data>(index_);
    }
    BluetoothSystem_GetState_ResponseParams_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t state;
  uint8_t padfinal_[4];

 private:
  BluetoothSystem_GetState_ResponseParams_Data();
  ~BluetoothSystem_GetState_ResponseParams_Data() = delete;
};
static_assert(sizeof(BluetoothSystem_GetState_ResponseParams_Data) == 16,
              "Bad sizeof(BluetoothSystem_GetState_ResponseParams_Data)");
class  BluetoothSystemClient_OnStateChanged_Params_Data {
 public:
  class BufferWriter {
   public:
    BufferWriter() = default;

    void Allocate(mojo::internal::Buffer* serialization_buffer) {
      serialization_buffer_ = serialization_buffer;
      index_ = serialization_buffer_->Allocate(sizeof(BluetoothSystemClient_OnStateChanged_Params_Data));
      new (data()) BluetoothSystemClient_OnStateChanged_Params_Data();
    }

    bool is_null() const { return !serialization_buffer_; }
    BluetoothSystemClient_OnStateChanged_Params_Data* data() {
      DCHECK(!is_null());
      return serialization_buffer_->Get<BluetoothSystemClient_OnStateChanged_Params_Data>(index_);
    }
    BluetoothSystemClient_OnStateChanged_Params_Data* operator->() { return data(); }

   private:
    mojo::internal::Buffer* serialization_buffer_ = nullptr;
    size_t index_ = 0;

    DISALLOW_COPY_AND_ASSIGN(BufferWriter);
  };

  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);

  mojo::internal::StructHeader header_;
  int32_t new_state;
  uint8_t padfinal_[4];

 private:
  BluetoothSystemClient_OnStateChanged_Params_Data();
  ~BluetoothSystemClient_OnStateChanged_Params_Data() = delete;
};
static_assert(sizeof(BluetoothSystemClient_OnStateChanged_Params_Data) == 16,
              "Bad sizeof(BluetoothSystemClient_OnStateChanged_Params_Data)");

#pragma pack(pop)

}  // namespace internal
}  // namespace mojom
}  // namespace device

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_INTERNAL_H_