// Copyright 2016 The Chromium Authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_H_
#define SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <ostream>
#include <type_traits>
#include <utility>

#include "base/compiler_specific.h"
#include "base/containers/flat_map.h"
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"
#include "services/device/public/mojom/bluetooth_system.mojom-shared-internal.h"

#include "mojo/public/cpp/bindings/lib/interface_serialization.h"


#include "mojo/public/cpp/bindings/native_enum.h"
#include "mojo/public/cpp/bindings/lib/native_struct_serialization.h"


namespace device {
namespace mojom {


}  // namespace mojom
}  // namespace device

namespace mojo {
namespace internal {

}  // namespace internal
}  // namespace mojo


namespace device {
namespace mojom {

enum class BluetoothSystem_State : int32_t {
  kUnsupported,
  kUnavailable,
  kPoweredOff,
  kTransitioning,
  kPoweredOn,
  kMinValue = 0,
  kMaxValue = 4,
};

inline std::ostream& operator<<(std::ostream& os, BluetoothSystem_State value) {
  switch(value) {
    case BluetoothSystem_State::kUnsupported:
      return os << "BluetoothSystem_State::kUnsupported";
    case BluetoothSystem_State::kUnavailable:
      return os << "BluetoothSystem_State::kUnavailable";
    case BluetoothSystem_State::kPoweredOff:
      return os << "BluetoothSystem_State::kPoweredOff";
    case BluetoothSystem_State::kTransitioning:
      return os << "BluetoothSystem_State::kTransitioning";
    case BluetoothSystem_State::kPoweredOn:
      return os << "BluetoothSystem_State::kPoweredOn";
    default:
      return os << "Unknown BluetoothSystem_State value: " << static_cast<int32_t>(value);
  }
}
inline bool IsKnownEnumValue(BluetoothSystem_State value) {
  return internal::BluetoothSystem_State_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class BluetoothSystemFactoryInterfaceBase {};

using BluetoothSystemFactoryPtrDataView =
    mojo::InterfacePtrDataView<BluetoothSystemFactoryInterfaceBase>;
using BluetoothSystemFactoryRequestDataView =
    mojo::InterfaceRequestDataView<BluetoothSystemFactoryInterfaceBase>;
using BluetoothSystemFactoryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<BluetoothSystemFactoryInterfaceBase>;
using BluetoothSystemFactoryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<BluetoothSystemFactoryInterfaceBase>;
class BluetoothSystemInterfaceBase {};

using BluetoothSystemPtrDataView =
    mojo::InterfacePtrDataView<BluetoothSystemInterfaceBase>;
using BluetoothSystemRequestDataView =
    mojo::InterfaceRequestDataView<BluetoothSystemInterfaceBase>;
using BluetoothSystemAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<BluetoothSystemInterfaceBase>;
using BluetoothSystemAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<BluetoothSystemInterfaceBase>;
class BluetoothSystemClientInterfaceBase {};

using BluetoothSystemClientPtrDataView =
    mojo::InterfacePtrDataView<BluetoothSystemClientInterfaceBase>;
using BluetoothSystemClientRequestDataView =
    mojo::InterfaceRequestDataView<BluetoothSystemClientInterfaceBase>;
using BluetoothSystemClientAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<BluetoothSystemClientInterfaceBase>;
using BluetoothSystemClientAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<BluetoothSystemClientInterfaceBase>;
class BluetoothSystemFactory_Create_ParamsDataView {
 public:
  BluetoothSystemFactory_Create_ParamsDataView() {}

  BluetoothSystemFactory_Create_ParamsDataView(
      internal::BluetoothSystemFactory_Create_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data), context_(context) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  UserType TakeSystem() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::BluetoothSystemRequestDataView>(
            &data_->system, &result, context_);
    DCHECK(ret);
    return result;
  }
  template <typename UserType>
  UserType TakeSystemClient() {
    UserType result;
    bool ret =
        mojo::internal::Deserialize<::device::mojom::BluetoothSystemClientPtrDataView>(
            &data_->system_client, &result, context_);
    DCHECK(ret);
    return result;
  }
 private:
  internal::BluetoothSystemFactory_Create_Params_Data* data_ = nullptr;
  mojo::internal::SerializationContext* context_ = nullptr;
};

class BluetoothSystem_GetState_ParamsDataView {
 public:
  BluetoothSystem_GetState_ParamsDataView() {}

  BluetoothSystem_GetState_ParamsDataView(
      internal::BluetoothSystem_GetState_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
 private:
  internal::BluetoothSystem_GetState_Params_Data* data_ = nullptr;
};

class BluetoothSystem_GetState_ResponseParamsDataView {
 public:
  BluetoothSystem_GetState_ResponseParamsDataView() {}

  BluetoothSystem_GetState_ResponseParamsDataView(
      internal::BluetoothSystem_GetState_ResponseParams_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadState(UserType* output) const {
    auto data_value = data_->state;
    return mojo::internal::Deserialize<::device::mojom::BluetoothSystem_State>(
        data_value, output);
  }

  BluetoothSystem_State state() const {
    return static_cast<BluetoothSystem_State>(data_->state);
  }
 private:
  internal::BluetoothSystem_GetState_ResponseParams_Data* data_ = nullptr;
};

class BluetoothSystemClient_OnStateChanged_ParamsDataView {
 public:
  BluetoothSystemClient_OnStateChanged_ParamsDataView() {}

  BluetoothSystemClient_OnStateChanged_ParamsDataView(
      internal::BluetoothSystemClient_OnStateChanged_Params_Data* data,
      mojo::internal::SerializationContext* context)
      : data_(data) {}

  bool is_null() const { return !data_; }
  template <typename UserType>
  WARN_UNUSED_RESULT bool ReadNewState(UserType* output) const {
    auto data_value = data_->new_state;
    return mojo::internal::Deserialize<::device::mojom::BluetoothSystem_State>(
        data_value, output);
  }

  BluetoothSystem_State new_state() const {
    return static_cast<BluetoothSystem_State>(data_->new_state);
  }
 private:
  internal::BluetoothSystemClient_OnStateChanged_Params_Data* data_ = nullptr;
};



}  // namespace mojom
}  // namespace device

namespace std {

template <>
struct hash<::device::mojom::BluetoothSystem_State>
    : public mojo::internal::EnumHashImpl<::device::mojom::BluetoothSystem_State> {};

}  // namespace std

namespace mojo {


template <>
struct EnumTraits<::device::mojom::BluetoothSystem_State, ::device::mojom::BluetoothSystem_State> {
  static ::device::mojom::BluetoothSystem_State ToMojom(::device::mojom::BluetoothSystem_State input) { return input; }
  static bool FromMojom(::device::mojom::BluetoothSystem_State input, ::device::mojom::BluetoothSystem_State* output) {
    *output = input;
    return true;
  }
};

namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::device::mojom::BluetoothSystem_State, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::device::mojom::BluetoothSystem_State, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(static_cast<::device::mojom::BluetoothSystem_State>(input), output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace device {
namespace mojom {










}  // namespace mojom
}  // namespace device

#endif  // SERVICES_DEVICE_PUBLIC_MOJOM_BLUETOOTH_SYSTEM_MOJOM_SHARED_H_
